unit mainform;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, Grids,
  StdCtrls, ExtCtrls, Clipbrd,LCLType, Menus;

type

  { TFmainform }

  TFmainform = class(TForm)
    PanelDeEnable: TPanel;
    PanelEoEnable: TPanel;
    TrayMenuAbout: TMenuItem;
    TrayMenuQuit: TMenuItem;
    TrayMenuShow: TMenuItem;
    TrayMenuHide: TMenuItem;
    TrayMenu: TPopupMenu;
    SearchWord: TEdit;
    GroupEspDeu: TGroupBox;
    GroupDeuEsp: TGroupBox;
    LabelFrage: TLabel;
    MemoAnleitung: TMemo;
    MemoDeut: TMemo;
    MemoEspa: TMemo;
    GridEspa: TStringGrid;
    GridDeut: TStringGrid;
    WaitSearch: TTimer;
    TrayIcon: TTrayIcon;
    procedure FormClose(Sender: TObject; var CloseAction: TCloseAction);
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure FormResize(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure MemoEspaChange(Sender: TObject);
    procedure SearchWordEnter(Sender: TObject);
    procedure SearchWordExit(Sender: TObject);
    procedure ShowWords;
    procedure FormCreate(Sender: TObject);
    procedure SearchWordChange(Sender: TObject);
    procedure TrayIconClick(Sender: TObject);
    procedure TrayMenuAboutClick(Sender: TObject);
    procedure TrayMenuHideClick(Sender: TObject);
    procedure TrayMenuQuitClick(Sender: TObject);
    procedure TrayMenuShowClick(Sender: TObject);
    procedure WaitSearchTimer(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  end;

var
  Fmainform: TFmainform;
  deut, espa : TStringList;
  Espamax, Espapos, Deutmax, Deutpos : Integer;


implementation

{$R *.lfm}

{ TFmainform }

procedure TFmainform.TrayIconClick(Sender: TObject);
begin
if Fmainform.Visible = True then
  begin
    Fmainform.Hide;
    TrayMenuShow.Enabled := True;
    TrayMenuHide.Enabled := False;
  end
else
  begin
    Fmainform.Show;
    TrayMenuShow.Enabled := False;
    TrayMenuHide.Enabled := True;
  end;
end;

procedure TFmainform.TrayMenuAboutClick(Sender: TObject);
begin
  Application.MessageBox('"LVortaro" ist ein Freeware-Deutsch-Esperanto-Wörterbuch von Thomas Schütz. Die aktuelle Programmversion findest du immer auf meiner Webseite: http://www.thschuetz.de.'
  + sLineBreak + sLineBreak +
  '"LVortaro" estas senpaga germana-esperanta-vortaro de Thomas Schütz. La adreso de mia hejmpaĝo estas: http://www.thschuetz.de. Ĉi tie vi ĉiam trovas la aktualan eldonon.'
  , 'Über LVortaro / Pri LVortaro',MB_ICONINFORMATION)
end;

procedure TFmainform.TrayMenuHideClick(Sender: TObject);
begin
  Fmainform.Hide;
  TrayMenuShow.Enabled := True;
  TrayMenuHide.Enabled := False;
end;

procedure TFmainform.TrayMenuQuitClick(Sender: TObject);
begin
  Fmainform.Close;
end;

procedure TFmainform.TrayMenuShowClick(Sender: TObject);
begin
   Fmainform.Show;
   TrayMenuShow.Enabled := False;
   TrayMenuHide.Enabled := True;
end;

procedure TFmainform.WaitSearchTimer(Sender: TObject);

var help : Boolean;
    index : integer;
    searchx : string;

begin
WaitSearch.Enabled := False;
searchx := SearchWord.Text;
searchx := StringReplace(searchx, 'ĉ', 'cx', [rfReplaceAll]);
searchx := StringReplace(searchx, 'Ĉ', 'Cx', [rfReplaceAll]);
searchx := StringReplace(searchx, 'ĝ', 'gx', [rfReplaceAll]);
searchx := StringReplace(searchx, 'Ĝ', 'Gx', [rfReplaceAll]);
searchx := StringReplace(searchx, 'ĥ', 'hx', [rfReplaceAll]);
searchx := StringReplace(searchx, 'Ĥ', 'Hx', [rfReplaceAll]);
searchx := StringReplace(searchx, 'ĵ', 'jx', [rfReplaceAll]);
searchx := StringReplace(searchx, 'Ĵ', 'Jx', [rfReplaceAll]);
searchx := StringReplace(searchx, 'ŝ', 'sx', [rfReplaceAll]);
searchx := StringReplace(searchx, 'Ŝ', 'Sx', [rfReplaceAll]);
searchx := StringReplace(searchx, 'ŭ', 'ux', [rfReplaceAll]);
searchx := StringReplace(searchx, 'Ŭ', 'Ux', [rfReplaceAll]);

//Suche in der Esperanto-Tabelle
help := espa.Find (searchx,index);
if index >= (Espamax) then index := Espamax-1;
EspaPos := index;

//Suche in der Deutsch-Tabelle
help := deut.Find (searchx,index);
if index >= (Deutmax) then index := Deutmax-1;
DeutPos := index;
ShowWords;
end;

procedure TFmainform.SearchWordChange(Sender: TObject);
begin
  WaitSearch.Enabled := False;
  WaitSearch.Enabled := True;
end;

procedure TFmainform.FormCreate(Sender: TObject);
begin
//Daten einlesen
     deut := TStringList.Create;
{$IFDEF DARWIN}
     deut.LoadFromFile (ExtractFilePath(Application.ExeName)+'../Resources/deutsch.txt');
{$ELSE}
     deut.LoadFromFile (ExtractFilePath(Application.ExeName)+'deutsch.txt');
{$ENDIF}
     deut.Sorted := true;
//     deut.SaveToFile (ExtractFilePath(Application.ExeName)+'deutsch_sorted.txt');
     Deutmax := deut.Count;
     espa := TStringList.Create;
{$IFDEF DARWIN}
     espa.LoadFromFile (ExtractFilePath(Application.ExeName)+'../Resources/esperanto.txt');
{$ELSE}
     espa.LoadFromFile (ExtractFilePath(Application.ExeName)+'esperanto.txt');
{$ENDIF}
     espa.Sorted := true;
//     espa.SaveToFile (ExtractFilePath(Application.ExeName)+'esperanto_sorted.txt');
     Espamax := espa.Count;
end;

procedure TFmainform.ShowWords;

var i, index:integer;
    wort:string;

begin
//Deutsch-Übersetzung anzeigen
index := Espapos;
wort := espa.Strings [index];
wort := copy (wort,pos(' ;',wort)+2,length(wort)-pos(' ;',wort));
MemoDeut.Text := wort;
for i := -2 to 3 do
    begin
    if ((index+i)<espa.Count) and ((index+i)>-1)  then
       begin
       wort := espa.Strings [index+i];
       wort := copy (wort,0,pos(' ;',wort));
       GridEspa.Cells [0,2+i] := wort;
       end
    else
        begin
        GridEspa.Cells [0,2+i] := '';
        end;
    end;
GridEspa.Row := 2;

//Esperanto-Übersetzung anzeigen
index := Deutpos;
wort := deut.Strings [index];
wort := copy (wort,pos(' ;',wort)+2,length(wort)-pos(' ;',wort));
MemoEspa.Text := wort;
for i := -2 to 3 do
    begin
    if ((index+i)<deut.Count) and ((index+i)>-1)  then
       begin
       wort := deut.Strings [index+i];
       wort := copy (wort,0,pos(' ;',wort));
       GridDeut.Cells [0,2+i] := wort;
       end
    else
        begin
        GridDeut.Cells [0,2+i] := '';
        end;
    end;
GridDeut.Row := 2;
end;

procedure TFmainform.FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState );
//  var s:string;
  var wort:string;
begin
//    str(Key, s);
//    ShowMessage (s);

  if Key = VK_Down then
    begin
      if Espapos < (Espamax-1) then
        Espapos := Espapos + 1;
      if Deutpos < (Deutmax-1) then
        Deutpos := Deutpos + 1;
      Key := 0;
      ShowWords;
    end;
  if Key = VK_Up then
    begin
      if Espapos > 0 then
        Espapos := Espapos - 1;
      if Deutpos > 0 then
        Deutpos := Deutpos - 1;
      Key := 0;
      ShowWords;
    end;
  if Key = 34 then   //Page-Down
    begin
      if Espapos < (Espamax - 6) then
        Espapos := Espapos + 5
        else Espapos := Espamax-1;
      if Deutpos < (Deutmax - 6) then
        Deutpos := Deutpos + 5
        else Deutpos := Deutmax-1;
      Key := 0;
      ShowWords;
    end;
  if Key = 33 then   //Page-Up
    begin
      if Espapos > 5 then
        Espapos := Espapos - 5
        else Espapos := 0;
      if Deutpos > 5 then
        Deutpos := Deutpos - 5
        else Deutpos := 0;
      Key := 0;
      ShowWords;
    end;
  if Key = 36 then   //Pos1
    begin
      Espapos := 0;
      Deutpos := 0;
      Key := 0;
      ShowWords;
    end;
  if Key = 35 then   //Ende
    begin
      Espapos := Espamax-1;
      Deutpos := Deutmax-1;
      Key := 0;
      ShowWords;
    end;
  if Key = 27 then   //Escape
    begin
      SearchWord.SetFocus;
      SearchWord.Text := '';
      Espapos := 0;
      Deutpos := 0;
      Key := 0;
      ShowWords;
    end;

  if (Key = 67) and (ssCtrl in Shift) then   //CTRL-C
    begin
    Clipboard.AsText := SearchWord.Text;
    Key := 0;
    end;
  if (Key = 88) and (ssCtrl in Shift) then   //CTRL-X
    begin
    Clipboard.AsText := SearchWord.Text;
    SearchWord.Text := '';
    Key := 0;
    end;
  if (Key = 86) and (ssCtrl in Shift) then   //CTRL-V
    begin
      if Clipboard.HasFormat(CF_Text) then
        SearchWord.Text := '';
    Key := 0;
    end;

  if Key = 112 then   //F1
    begin
      wort := espa.Strings [Espapos];
      wort := copy (wort,pos(' ;',wort)+2,length(wort));
      Clipboard.AsText := GridEspa.Cells [0,2]+'= '+wort;
    end;
  if Key = 113 then   //F2
    begin
      wort := deut.Strings [Deutpos];
      wort := copy (wort,pos(' ;',wort)+2,length(wort));
      Clipboard.AsText := GridDeut.Cells [0,2]+'= '+wort;
    end;
end;

procedure TFmainform.FormClose(Sender: TObject; var CloseAction: TCloseAction);
begin
  deut.Free;
  espa.Free;
end;

procedure TFmainform.FormResize(Sender: TObject);
begin
Fmainform.Height := 520;
if Fmainform.Width < 850 then Fmainform.Width := 850;
end;

procedure TFmainform.FormShow(Sender: TObject);
begin
ShowWords;
end;

procedure TFmainform.MemoEspaChange(Sender: TObject);
begin

end;

procedure TFmainform.SearchWordEnter(Sender: TObject);
begin
SearchWord.SelStart := length(SearchWord.Text);
end;

procedure TFmainform.SearchWordExit(Sender: TObject);
begin
  SearchWord.SetFocus;
end;

end.

